<app-content-layout>
  <mat-drawer-container class="services-container">
    <mat-drawer mode="side" opened>
      <app-services-sidenav></app-services-sidenav>
    </mat-drawer>
    <mat-drawer-content>
      <h3 class="heading-services">Services and APi</h3>
      <div class="container-fluid">
        <div class="row">
          <div class="col-lg-10">
            <form class="example-form" [formGroup]="serviceMasterForm" (ngSubmit)="onSubmit()">
              <div class="row">
                <div class="col-lg-6">
                  <mat-card class="custom-card-styling mb-4">
                    <mat-card-header>
                      <mat-card-title>Service Identifier</mat-card-title>
                    </mat-card-header>
                    <div class="row form-group">
                      <div class="col-lg-6">
                        <mat-form-field class="example-full-width w-100">
                          <mat-label>Service ID</mat-label>
                          <input matInput placeholder="12345" value="" formControlName="srv_id">
                          <mat-error *ngIf="serviceMasterForm.controls.srv_id.errors?.required">Required</mat-error>
                          <mat-error *ngIf="serviceMasterForm.controls.srv_id.errors?.minlength">Minimum 8 charecters
                            please</mat-error>
                          <mat-error *ngIf="serviceMasterForm.controls.srv_id.errors?.maxlength">Maximum 56 charecters
                            please</mat-error>
                        </mat-form-field>
                      </div>
                      <div class="col-lg-2 d-flex align-items-center">
                        <mat-checkbox class="example-margin">Generate?</mat-checkbox>
                      </div>
                    </div>
                    <div class="row">
                      <div class="col-lg-6">
                        <mat-form-field class="example-full-width w-100">
                          <mat-label>Name</mat-label>
                          <input matInput placeholder="" value="" formControlName="serviceName">
                          <mat-error *ngIf="serviceMasterForm.controls.serviceName.errors?.required">Required
                          </mat-error>
                          <mat-error *ngIf="serviceMasterForm.controls.serviceName.errors?.minlength">Minimum 8
                            charecters please</mat-error>
                          <mat-error *ngIf="serviceMasterForm.controls.serviceName.errors?.maxlength">Maximum 128
                            charecters please</mat-error>
                        </mat-form-field>
                      </div>

                      <div class="col-6">
                        <mat-form-field class="example-full-width w-100">
                          <mat-label>Title</mat-label>
                          <input matInput placeholder="" formControlName="serviceTitle">
                          <mat-error *ngIf="serviceMasterForm.controls.serviceTitle.errors?.required">Required
                          </mat-error>
                          <mat-error *ngIf="serviceMasterForm.controls.serviceTitle.errors?.minlength">Minimum 16
                            charecters please</mat-error>
                          <mat-error *ngIf="serviceMasterForm.controls.serviceTitle.errors?.maxlength">Maximum 256
                            charecters please</mat-error>
                        </mat-form-field>
                      </div>
                    </div>
                  </mat-card>
                </div>
                <div class="col-lg-6">
                  <mat-card class="custom-card-styling mb-4">
                    <mat-card-header>
                      <mat-card-title>Service Metadata</mat-card-title>
                    </mat-card-header>
                    <div class="row">
                      <div class="col-lg-6">
                        <mat-form-field class="example-full-width w-100">
                          <mat-label>Group Slug</mat-label>
                          <input matInput placeholder="" value="" formControlName="group_slug">
                          <mat-error *ngIf="serviceMasterForm.controls.group_slug.errors?.required">Required</mat-error>
                          <mat-error *ngIf="serviceMasterForm.controls.group_slug.errors?.minlength">Minimum 8
                            charecters please</mat-error>
                          <mat-error *ngIf="serviceMasterForm.controls.group_slug.errors?.maxlength">Maximum 128
                            charecters please</mat-error>
                        </mat-form-field>
                      </div>

                      <div class="col-lg-6">
                        <mat-form-field class="example-full-width w-100">
                          <mat-label>Group Name</mat-label>
                          <input matInput placeholder="" value="" formControlName="group_name">
                          <mat-error *ngIf="serviceMasterForm.controls.group_name.errors?.required">Required</mat-error>
                          <mat-error *ngIf="serviceMasterForm.controls.group_name.errors?.minlength">Minimum 8
                            charecters please</mat-error>
                          <mat-error *ngIf="serviceMasterForm.controls.group_name.errors?.maxlength">Maximum 256
                            charecters please</mat-error>
                        </mat-form-field>
                      </div>
                    </div>
                    <div class="row">
                      <div class="col-lg-6">
                        <mat-form-field class="example-full-width w-100">
                          <mat-label>Hostname</mat-label>
                          <input matInput placeholder="" value="" formControlName="hostname">
                          <mat-error *ngIf="serviceMasterForm.controls.hostname.errors?.required">Required</mat-error>
                          <mat-error *ngIf="serviceMasterForm.controls.hostname.errors?.maxlength">Maximum 128
                            charecters please</mat-error>
                        </mat-form-field>
                      </div>
                      <div class="col-lg-6">
                        <mat-form-field class="example-full-width w-100">
                          <mat-label>Port</mat-label>
                          <input matInput placeholder="" value="" formControlName="port">
                          <mat-error *ngIf="serviceMasterForm.controls.port.errors?.required">Required</mat-error>
                          <mat-error *ngIf="serviceMasterForm.controls.port.errors?.pattern">Numbers only please
                          </mat-error>
                        </mat-form-field>
                      </div>
                    </div>
                  </mat-card>
                </div>
              </div>


              <div class="row">
                <div class="col-lg-4 mb-4">
                  <mat-card class="custom-card-styling h-100">
                    <mat-card-header>
                      <mat-card-title>Important URIs</mat-card-title>
                    </mat-card-header>
                    <div class="row">
                      <div class="col-lg-12">
                        <mat-form-field class="example-full-width w-100">
                          <mat-label>Context Root</mat-label>
                          <input matInput placeholder="" value="" formControlName="ctx_root">
                          <mat-error *ngIf="serviceMasterForm.controls.ctx_root.errors?.maxlength">Maximum 256
                            charecters please</mat-error>
                        </mat-form-field>
                      </div>
                    </div>
                    <div class="row">
                      <div class="col-lg-12">
                        <mat-form-field class="example-full-width w-100">
                          <mat-label>SDK Doc URI</mat-label>
                          <input matInput placeholder="" value="" formControlName="sdk_doc_uri">
                          <mat-error *ngIf="serviceMasterForm.controls.sdk_doc_uri.errors?.maxlength">Maximum 256
                            charecters please</mat-error>
                        </mat-form-field>
                      </div>

                      <div class="col-lg-12">
                        <mat-form-field class="example-full-width w-100">
                          <mat-label>API Doc URI</mat-label>
                          <input matInput placeholder="" value="" formControlName="api_doc_uri">
                          <mat-error *ngIf="serviceMasterForm.controls.api_doc_uri.errors?.maxlength">Maximum 256
                            charecters please</mat-error>
                        </mat-form-field>
                      </div>
                    </div>
                  </mat-card>
                </div>
                <div class="col-lg-8 mb-4">
                  <mat-card class="custom-card-styling h-100 ">
                    <mat-card-header>
                      <mat-card-title>Service Management</mat-card-title>
                    </mat-card-header>
                    <div class="row">
                      <div class="col-lg-4">
                        <mat-form-field appearance="standard">
                          <mat-label>Visibility</mat-label>
                          <mat-select formControlName="visibility">
                            <mat-option *ngFor="let vs of visibility" [value]="vs.value">
                              {{vs.viewValue}}
                            </mat-option>
                          </mat-select>
                          <mat-error
                            *ngIf="(this.serviceMasterForm.get('visibility').errors?.required && this.serviceMasterForm.get('visibility').touched)">
                            Required</mat-error>
                        </mat-form-field>
                      </div>

                      <div class="col-lg-4">
                        <mat-form-field appearance="standard">
                          <mat-label>Type</mat-label>
                          <mat-select formControlName="type">
                            <mat-option *ngFor="let type of types" [value]="type.value">
                              {{type.viewValue}}
                            </mat-option>
                          </mat-select>
                          <mat-error
                            *ngIf="(this.serviceMasterForm.get('type').errors?.required && this.serviceMasterForm.get('type').touched)">
                            Required</mat-error>
                        </mat-form-field>
                        <!-- <mat-error *ngIf="serviceMasterForm.controls.type.errors?.required">Required</mat-error> -->
                      </div>

                      <div class="col-lg-4">
                        <mat-form-field appearance="standard">
                          <mat-label>Lifecycle</mat-label>
                          <mat-select formControlName="lifecycle">
                            <mat-option *ngFor="let lc of lifecycle" [value]="lc.value">
                              {{lc.viewValue}}
                            </mat-option>
                          </mat-select>
                          <mat-error
                            *ngIf="this.serviceMasterForm.get('lifecycle').errors?.required && this.serviceMasterForm.get('lifecycle').touched">
                            Required</mat-error>
                        </mat-form-field>
                      </div>
                    </div>


                    <div class="" formGroupName="discussion_chl_uri">
                      <div class="row">
                        <div class="col-lg-6">
                          <mat-form-field class="example-full-width w-100">
                            <mat-label>Discussion Channel Type</mat-label>
                            <input matInput placeholder="" value="" formControlName="type">
                          </mat-form-field>
                          <mat-error *ngIf="serviceMasterForm.controls.type.errors?.maxlength">Maximum 256 charecters
                            please
                          </mat-error>
                        </div>
                        <div class="col-lg-6">
                          <mat-form-field class="example-full-width w-100">
                            <mat-label>Discussion Channel URL</mat-label>
                            <input matInput placeholder="" value="" formControlName="url">
                          </mat-form-field>
                        </div>
                      </div>
                    </div>
                    <div class="col-lg-6">
                      <mat-form-field class="example-full-width w-100">
                        <mat-label>tags</mat-label>
                        <input matInput placeholder="" value="" formControlName="tags">
                        <mat-error *ngIf="serviceMasterForm.controls.tags.errors?.maxlength">Maximum 256 charecters
                          please
                        </mat-error>
                      </mat-form-field>
                    </div>

                  </mat-card>
                </div>
              </div>




              <mat-card class="custom-card-styling mb-4">
                <div class="row">
                  <div class="col-lg-12 tabs-create">

                    <mat-tab-group dynamicHeight>

                      <mat-tab label="Implementation Technology Details">

                        <div class="container mt-3" formGroupName="imp_tech_uri">
                          <div class="row">
                            <div class="col-lg-8">
                              <mat-form-field appearance="standard">
                                <mat-label>Implemented In</mat-label>
                                <mat-select formControlName="type" class="w-100">
                                  <mat-option *ngFor="let implementation of implementations "
                                    [value]="implementation.value">
                                    {{implementation.viewValue}}
                                  </mat-option>
                                </mat-select>
                                <mat-error
                                  *ngIf="this.serviceMasterForm.get('imp_tech_uri.type').errors?.required && this.serviceMasterForm.get('imp_tech_uri.type').touched">
                                  Required</mat-error>
                              </mat-form-field>
                            </div>
                          </div>
                          <div class="row">
                            <div class="col-lg-4">
                              <mat-form-field class="example-full-width w-100">
                                <mat-label>Framework Version</mat-label>
                                <input matInput placeholder="" value="" formControlName="version">
                                <!-- <mat-error *ngIf="serviceMasterForm.controls.tags.errors?.maxlength">Maximum 256 charecters please</mat-error> -->
                                <mat-error *ngIf="this.serviceMasterForm.get('imp_tech_uri.version').errors?.required">
                                  Required</mat-error>
                              </mat-form-field>
                            </div>
                            <div class="col-lg-4 d-flex align-items-center">
                              <mat-checkbox class="example-margin" formControlName="isContainerized">Containerized?
                              </mat-checkbox>
                            </div>
                          </div>
                        </div>
                      </mat-tab>


                      <mat-tab label="Source Repo Details">
                        <div class="container mt-3" formGroupName="source_uri">
                          <div class="row">
                            <div class="col-lg-4">
                              <mat-form-field appearance="standard">
                                <mat-label>Type</mat-label>
                                <mat-select formControlName="repo_type">
                                  <mat-option *ngFor="let sr of sourceRepo " [value]="sr.value">
                                    {{sr.viewValue}}
                                  </mat-option>
                                </mat-select>
                              </mat-form-field>
                            </div>
                            <div class="col-lg-4">
                              <mat-form-field appearance="standard">
                                <mat-label>Tech</mat-label>
                                <mat-select formControlName="repo_tech">
                                  <mat-option *ngFor="let th of tech " [value]="th.value">
                                    {{th.viewValue}}
                                  </mat-option>
                                </mat-select>
                              </mat-form-field>
                            </div>
                          </div>
                          <div class="row">
                            <div class="col-lg-8">
                              <mat-form-field class="example-full-width w-100">
                                <mat-label>URL</mat-label>
                                <input matInput placeholder="" value="" formControlName="repo_url">
                                <mat-error *ngIf="serviceMasterForm.controls.type.errors?.maxlength">Maximum 256
                                  charecters please</mat-error>
                              </mat-form-field>
                            </div>
                          </div>
                          <div class="row">
                            <div class="col-lg-8">
                              <mat-form-field class="example-full-width w-100">
                                <mat-label>Branch</mat-label>
                                <input matInput placeholder="" value="" formControlName="repo_branch">
                              </mat-form-field>
                            </div>
                          </div>
                        </div>
                      </mat-tab>
                      <mat-tab label="Service Owner Details">
                        <div class="container mt-3" formGroupName="service_owner">
                          <div class="row">
                            <div class="col-lg-4">
                              <mat-form-field class="w-100">
                                <mat-label>Service Owner Id</mat-label>
                                <input matInput placeholder="" value="" formControlName="so_id">
                              </mat-form-field>
                            </div>
                            <div class="col-lg-4">
                              <mat-form-field class="w-100">
                                <mat-label>Service Id</mat-label>
                                <input matInput placeholder="" value="" formControlName="so_service_id">
                              </mat-form-field>
                            </div>
                          </div>
                          <div class="row">
                            <div class="col-lg-4">
                              <mat-form-field class="example-full-width w-100">
                                <mat-label>Name</mat-label>
                                <input matInput placeholder="" value="" formControlName="so_name">
                              </mat-form-field>
                            </div>
                            <div class="col-lg-4">
                              <mat-form-field class="example-full-width w-100">
                                <mat-label>Email Id</mat-label>
                                <input matInput placeholder="" value="" formControlName="so_email_id">
                              </mat-form-field>
                            </div>
                          </div>
                          <div class="row">
                            <div class="col-lg-4">
                              <mat-form-field class="example-full-width w-100">
                                <mat-label>Escalation Rank</mat-label>
                                <input type="number" matInput placeholder="" value="" formControlName="so_esc_rank">
                              </mat-form-field>
                            </div>
                          </div>
                        </div>
                      </mat-tab>

                    </mat-tab-group>
                  </div>
                </div>
              </mat-card>
              <button type="submit" mat-raised-button color="primary" mat-button>Create</button>


            </form>





          </div>
        </div>
      </div>
    </mat-drawer-content>
  </mat-drawer-container>

</app-content-layout>
